package yrpg.application.crmvisit.plugin.form;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.List;

/**
 * 单据转换插件
 * 源单:专家库
 * 目标单:市场维护人
 */
public class ExpertDatabasePushConvertPlugin extends AbstractConvertPlugIn implements Plugin {
    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        ExtendedDataEntity[] extendedDataEntities = e.getTargetExtDataEntitySet().FindByEntityKey("yrpg_relationship_bind");
        for (ExtendedDataEntity extendedDataEntity : extendedDataEntities) {
            DynamicObject dataEntity = extendedDataEntity.getDataEntity();
            //获取源单中传入要转换的对象
            List<DynamicObject> convertSource = (List<DynamicObject>) extendedDataEntity.getValue("ConvertSource");
            for (DynamicObject source : convertSource) {
                DynamicObject object = BusinessDataServiceHelper.loadSingle(source.getLong("id"), "yrpg_crm_expert");
                dataEntity.set("yrpg_expert_name", object);
                dataEntity.set("billstatus", "C");
            }
        }
    }
}