package yrpg.application.crmvisit.plugin.form;

import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.BizDataEventArgs;
import kd.bos.ext.form.control.CustomControl;
import kd.bos.form.IFormView;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.form.plugin.AbstractMobFormPlugin;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * 动态表单插件
 */
public class crmVisitDetailMobFormPlugin extends AbstractMobFormPlugin implements Plugin {
    @Override
    public void setView(IFormView formView) {
        super.setView(formView);
        System.out.println(formView);
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        String taskStatus = String.valueOf(this.getModel().getValue("yrpg_taskstatus"));
        String signIn = String.valueOf(this.getModel().getValue("yrpg_sign_in"));
        String signOut = String.valueOf(this.getModel().getValue("yrpg_sign_out"));
        this.getView().setVisible(false, "yrpg_mbaritemap3", "yrpg_mbaritemap4");
        if (taskStatus.equals("B") && "0".equals(signIn)) {
            //待签到,范围外
            this.getView().setVisible(false, "yrpg_mbaritemap");
            this.getView().setVisible(true, "yrpg_mbaritemap3");
        } else if (taskStatus.equals("C") && "0".equals(signOut)) {
            this.getView().setVisible(false, "yrpg_mbaritemap1");
            this.getView().setVisible(true, "yrpg_mbaritemap4");
        }
        CustomControl customcontrol = this.getView().getControl("yrpg_customcontrolap");
        Map<String, String> address = getAddress();
        if (address != null) {
            customcontrol.setData(address);
        }
        Object mobTBMain = this.getView().getFormShowParameter().getCustomParam("mobTBMain");
        if (mobTBMain != null) {
            this.getView().setVisible(false, "tbmain");
        }
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        Object visitDate = this.getView().getFormShowParameter().getCustomParam("visitDate");
        if (visitDate != null) {
            this.getModel().setValue("yrpg_appointment_time", visitDate);

        }
    }


    @Override
    public void createNewData(BizDataEventArgs e) {
        super.createNewData(e);
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit expert = this.getView().getControl("yrpg_expert");
        expert.addBeforeF7SelectListener(new BeforeF7SelectListener() {
            @Override
            public void beforeF7Select(BeforeF7SelectEvent f7) {
                String name = f7.getProperty().getName();
                if (name.equals("yrpg_expert")) {
                    ListShowParameter list = (ListShowParameter) f7.getFormShowParameter();
                    QFilter filter = new QFilter("billstatus", QCP.equals, "C");
                    filter.and("entryentity.yrpg_maintainer.id", QCP.equals, RequestContext.get().getCurrUserId());
                    DynamicObjectCollection expertColl = QueryServiceHelper.query("yrpg_relationship_bind", "yrpg_expert_name", filter.toArray());
                    Set<Long> expertId = expertColl.stream().map(x -> x.getLong("yrpg_expert_name")).collect(Collectors.toSet());
                    QFilter filter_1 = new QFilter("id", QCP.in, expertId);
                    list.getListFilterParameter().setFilter(filter_1);
                }
            }
        });
    }


    private Map<String, String> getAddress() {
        DynamicObject dynamicObject = (DynamicObject) this.getModel().getValue("yrpg_expert");
        if (dynamicObject == null) {
            return null;
        }
        QFilter filter = new QFilter("number", QCP.equals, dynamicObject.get("number"));
        DynamicObject expert = QueryServiceHelper.queryOne("yrpg_crm_expert", "yrpg_expert_name", new QFilter[]{filter});
        QFilter filter1 = new QFilter("id", QCP.equals, expert.get(0));
        DynamicObject crmVisit = QueryServiceHelper.queryOne("yrpg_yzj_expert_base", "yrpg_address, yrpg_expert_city", new QFilter[]{filter1});
        Map<String, String> map = new HashMap<>();
        map.put("address", crmVisit.getString("yrpg_address"));
        map.put("city", crmVisit.getString("yrpg_expert_city"));
        return map;
    }
}
