package yrpg.application.crmvisit.plugin.operate;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.List;

/**
 * 单据操作插件
 * 员工上下级权限关系
 */
public class CrmUserOpPlugin extends AbstractOperationServicePlugIn implements Plugin {

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("yrpg_leader");
    }
    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new CrmUserValidator());
    }
    class CrmUserValidator extends AbstractValidator {

        @Override
        public void validate() {
            String opKey = this.getOperateKey();
            ExtendedDataEntity[] dataEntities = getDataEntities();
            for (ExtendedDataEntity data : dataEntities) {
                DynamicObject entity = data.getDataEntity();
                if (opKey.equals("save") || opKey.equals("submit")) {
                    DynamicObject leader = entity.getDynamicObject("yrpg_leader");
                    if (leader!=null){
                        long leaderId   = leader.getLong("id");
                        QFilter filter = new QFilter("yrpg_leader.id", QCP.equals, leaderId);
                        filter.and("status",QCP.equals,"C");
                        filter.and("enable",QCP.equals,"1");
                        DynamicObject crmUser = QueryServiceHelper.queryOne("yrpg_yzj_crm_user", "id", filter.toArray());
                        if (crmUser!=null){
                            this.addMessage(data,"上级已存在，且不可新增");
                        }
                    }
                }
            }
        }
    }
}